# -*- coding: utf8 -*-

import mod_mysql, urllib2, repartidor
import htmlentitydefs

def sanitize(url):
    for (o,d) in htmlentitydefs.entitydefs.items():
        url = url.replace("&%s;"%o,d)
    return url

import infodb
dbusr,dbclv = infodb.get()
bdd = mod_mysql.DataBase("localhost", dbusr, dbclv, "tanique_plog")

def check_url(url,id):
    try:
        urllib2.urlopen(url)
        return "ok"
    except urllib2.HTTPError, e:
        return e.code
    except urllib2.URLError, e:
        return "name error"
    except Exception, e:
        return "error desconocido: %s" % e

def main():
    res = bdd.accion("select article_id, date, text, topic from plog_articles inner join plog_articles_text on plog_articles.id=plog_articles_text.article_id;")
    print "Encontramos %d articulos" % len(res)

    urls = []
    for (artid, date, text, topic) in res:
        base = 0
        while True:
            try:
                pos = text.index("http", base)
            except ValueError:
                break

            caracdelim = text[pos-1]
            fin = text.index(caracdelim, pos)
            url = text[pos:fin]
            urls.append((sanitize(url),artid))
            base = fin
    print "Encontramos %d urls" % len(urls)

    repart = repartidor.Repartidor(check_url, 20)
    for ((url,artid), status) in repart.procesar(urls):
        print "%15s - (%s) %r" % (status, artid, url)
    repart.fin()
        
if __name__ == "__main__":
    main()
